
# reset workspace ####
rm(list=ls())

#setwd ####
setwd("P:/IMEBI/DigiHero_Teilnehmerdaten/Massenmails/tokenaufbereiter")

cat("\n")
cat("Hallo Benutzer*in: Du hast das Script für den Tokenaufbereiter gestartet.\n")
cat("Nachfolgend werden jetzt:\n")
cat("- Alle notwendigen Pakete geladen.\n")
cat("- Alle erforderlichen Teilnehmerdaten aus den nachfolgenden Umfragen heruntergeladen.\n")
cat("+ 433442\n")
cat("+ 144481\n")
cat("+ 538473\n")
cat("-> Dauert ca. 10-20 Sekunden.\n")
cat("\n")
cat("####\n")
cat("At the end, the files are stored in the following working directory:\n")
cat(getwd(),"\n")
cat("####\n")
suppressWarnings({
suppressMessages({
#### DOWNLOAD Vorarbeit####
library(readxl)
library(writexl)
library(tidyverse)

#Start with user interaction: Pfad in Abhängigkeit von der Aufgabe wählen ####
  
source("./function_load.R")

#get download key#
source("./download_get_key.R")
})
})
#### DOWNLOAD Ausführung###

#Umfragen ID:
# 433442
# |> diese Umfrage staret bei ID 43 und endet bei: 92813 (Stand: März 2024)
# |> Funktion: get_last_id habe nicht gefunden. Wert muss daher im Skript manuell angepasst werden.
# 144481
# 538473


#Vorlage für Download von den Antworten der Teilnehmer###
#ls_433442_0 <- get_responses(iSurveyID= 433442, sLanguageCode= 'de', sResponseType='short',
#                             iFromResponseID =1,
#                             iToResponseID=50)

#Download der Daten der Umfrageteilnehmer selbst###
#Schleife geht nicht -> keine Ahung warum
# for(i in 1:2){
#   paste0(lp,i)<- get_participants(iSurveyID = 433442,iStart=as.Integer(paste0(i,0001)),iLimit =as.Integer(paste0(i+1,0000)), bUnused=FALSE, aAttributes=FALSE)
#   #lp1<- get_participants(iSurveyID = 433442,iStart=20001,iLimit = 20000, bUnused=FALSE, aAttributes=FALSE)
# }
#wenn iLimit > 50.000 gibt es eine Fehlermeldung

#problem: token, firstname, etc. gets automatic downloaded
# you have to added the extra columns that needed
atr <- c(
  "emailstatus",
  "language"
  )
# nach Mareikes Skript wird nur die Spalte "language" und "emailstatus" benötigt
# -> emailstatus beinhaltet die Information "INVALID", damit Limesurvey keine Mails an diese Adressen sendet.
#atr <- c(
#  "emailstatus", "language","validfrom","validuntil","remindercount","completed","invited","reminded","usesleft")
# Die folgenden Spalten werden nicht geladen -> keine Ahnung warum. Sie werden auch nicht geladen, wenn man nur diese eingibt.
# Es gibt aber anscheinend keine implizite Mengenbeschränkung.
#"invited",
#"reminded",

p_433442_00<- get_participants(iSurveyID = 433442,iStart=1,iLimit = 50000, bUnused=FALSE, aAttributes=atr)
p_433442_01<- get_participants(iSurveyID = 433442,iStart=50001,iLimit = 100000, bUnused=FALSE, aAttributes=atr)
cat("####\n")
cat("Der größte Wert aus der Umfrage 433442 zeigt: ")
print(max(p_433442_01$tid, na.rm = TRUE))
if(max(p_433442_01$tid, na.rm = TRUE)>=99500){
  cat("Die tid der Tabelle 433442 steht kurz vor 100.000 -> nochmal im Skript schauen, damit der Ablauf passt.\n")
  cat("Nachdem tid >= 100.001 wird die dritte Datei der Umfrage 433442 geladen und nicht mehr gelöscht.\n")  
}
cat("####\n")
cat("\n")
#Umfrage zum Zeitpunkt des Scriptes noch leer
#Die Datei enhält eine Spalte mit name status : "No survey participants found."
p_433442_02 <- get_participants(iSurveyID = 433442,iStart=100001,iLimit = 150000, bUnused=FALSE, aAttributes=FALSE)
#daher: solange die Tabelle leer ist, wird sie gleich wieder gelöscht
if("status" %in% colnames(p_433442_02)){
  rm(p_433442_02)
}else if (max(p_433442_02$tid, na.rm = TRUE)>=0){
  cat("Das Skript lädt jetzt den 3.Teil der Umfrage: 433442\n")
  cat("Das aktuelle Tid beträgt:")
  print(max(p_433442_02$tid, na.rm = TRUE))
  cat("\n")
}


p_144481_00 <- get_participants(iSurveyID = 144481,iStart=1,iLimit = 50000, bUnused=FALSE, aAttributes=atr)

p_538473_00<- get_participants(iSurveyID = 538473,iStart=1,iLimit = 50000, bUnused=FALSE, aAttributes=atr)

#erste Idee für die Weiterarbeit ####
#binden und "tid" entfernen
#token144481 <- read.csv("tokens_144481.csv")
#token433442 <- read.csv("tokens_433442.csv")
#token538473 <- read.csv("tokens_538473.csv")
#token <- bind_rows(token144481,token433442,token538473)
#token <- token |> select (-c(tid)) |> distinct()

#alle "Test"-Zeilen entfernen
#TestTokens NUR über firstname identifizieren
#token<- token |> filter(!str_detect(tolower(firstname), 'test'))


cat("####\n")
cat("Der Download wurde abgeschlossen.\n")
cat("Nun werden die heruntergeladen Tabellen verbunden.\n")
cat("####\n")



#Daten Verarbeiten####
# Verbinden was ein data.frame ist.
# in diesem Code gibt es eh nur data.frame
filtered_data_frames <- Filter(function(x) is.data.frame(get(x)), ls())

# die "values" zu "Data" machen und die participant_info entschachteln
data_frames_list <- lapply(filtered_data_frames, get)
suppressWarnings({
  
data_frames_list2 <- lapply(data_frames_list, unnest)
})
# zusammenhängendes data.frame erzeugen, tid entfernen und doppelte werte löschen
combined_df <- do.call(rbind, data_frames_list2)
combined_df$tid <- NULL
unique_df <- combined_df[!duplicated(combined_df), ]

#löschen der Testdaten
values_to_delete = c("Test1","Test2","Test3","Test4","Test5","Test6","Test7","Test8","Test9",
                     "Test10","Test11","Test12","test","Test","Test Bestätigungsmail","Mareike Test",
                     "Test Mareike","Bianca TEST","AlexandraTest")

removed_test_values <- unique_df[!unique_df$firstname %in% values_to_delete, ]

#SAS und Anführungszeichen -> entfällt hier in R ####

#Umlaute ersetzen####


cleaned_df <- removed_test_values |> mutate(across(firstname | lastname, 
                                \(x) stringr::str_replace_all(string = x, 
                                                              c('ä' = 'ae',
                                                                'ë' = 'ee',
                                                                'ï' = 'ie',
                                                                'ü' = 'ue', 
                                                                'ö' = 'oe',
                                                                'ß' = 'ss',
                                                                'ö' = 'oe',
                                                                '`' = '',
                                                                '´' = '',
                                                                'š' = 's',
                                                                'Ž' = 'z',
                                                                '–' = '-',
                                                                'õ' = 'oe'
                                                              ))))

#Die nicht geladenen Spalten neu einbinden und mit festen Werten speichern####
#Enstprechend der alten Vorgaben im SAS-Script von Mareike

cleaned_df$validfrom <- ""
cleaned_df$validuntil <- ""
cleaned_df$invited <- "N"
cleaned_df$reminded <- "N"
cleaned_df$remindercount <- "0"
cleaned_df$completed <- "N"
cleaned_df$usesleft <- "1"



function_start()